program PCX2HP;                     {laserjet/deskjet printers}
uses dos,printer;                   {prints only to LPT1}
var Z : array[1..128] of byte;      {PCX header}
    lgth,width,bpl : integer;       {bpl = bytes/line}
    mono : boolean;                 {can only decode monochrome data}
    k : integer; S,T : string[100];
    f : file;                       {PCX file handle}
    fs : pathstr;                   {PCX file name}
    bpls : string[3];               {byte/line converted to a string}

procedure readpcxhdr;
var yn : char;
begin

 write('Which PCX file to print? ');
 readln(fs);
 assign(f,fs);
 {$I-}
 reset(f,1);
 {$I+}
 if IOResult <> 0 then
  begin
   writeln('CANNOT READ FILE ',FS);
   HALT(1);
  end;
 blockread(f,Z,128);
 lgth  := Z[11] + Z[12]*256 +1;
 width := Z[9]  + Z[10]*256 +1;
 writeln('WIDTH = ',width:3,'  LENGTH = ',lgth:3);
 bpl := Z[67];
 if Z[66] = 1 then mono := true else mono := false;
 writeln(bpl:2,' bytes/line');
 if bpl > 120 then                          {maximum the printer can handle}
  begin
   writeln('WIDTH TOO LARGE!');
   halt(1);
  end;
 if bpl mod 8 <> 0 then
  begin
   writeln('BAD PCX FORMAT');               {must be a multiple of 8}
   halt(1);
  end;
 if NOT mono then
  begin
   writeln('NOT A MONOCHROME PCX FILE');
   halt(1);
  end;
 writeln;
 write('Printer Ready, Continue? Y/N ');    {program crashes if not ready}
 readln(YN);
 if NOT (YN in ['y','Y']) then
  begin
   close(f);
   halt(0);
  end;
end;

procedure fillS;   {decode PCX data and convert to string for printing}
var b : byte; cnt,i,j : integer; {decoded PCX and Laserjet are very similar}
begin
 S := '';
 cnt := 0;
 while (length(s) < bpl) and (NOT EOF(f)) do
  begin
   blockread(f,b,1);
   if b < 192 then S := S+chr(255-b);
   if b > 192 then
    begin
     cnt := b-192;
     if NOT EOF(F) then blockread(f,b,1);
     for i := 1 to cnt do
      S := S + chr(255-b);
    end;
  end;
end;

   begin
     readpcxhdr;
     str(bpl:3,bpls);
     if bpls[1] = ' ' then delete(bpls,1,1);
     T := #27+'*b'+bpls+'W';          {tell laserjet #bytes/line}
     S := #27+'*t150R'+#27+'*rA';     {set to 150 dpi, 100 & 300 also valid}
     write(Lst,S);
     for k := 1 to lgth do
     begin
      fillS;
      write(Lst,T+S);
      write(k:3,#13);               {running # on screen to indicate working}
     end;
     S := #27+'*rB'+#12;            {end graphics output and line feed}
     write(Lst,S);
     close(f);
     writeln('SUCCESSFULL');
  end.

